# Artificial Intelligence and Machine Learning Projects
Projects completed as a part of Great Learning's PGP - Artificial Intelligence and Machine Learning.

## Installation
```
$ git clone https://github.com/sharmapratik88/AIML-Projects.git
$ cd AIML-Projects
```

## Projects done
**1. Statistical Learning**
   - Covers Descriptive Statistics, Probability & Conditional Probability, Hypothesis Testing, Inferential Statistics, Probability Distributions, Types of distribution and Binomial, Poisson & Normal distribution.
      - **Project link:** [Applied Stats](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/01_Applied%20Stats/01_Medical%20Cost%20Dataset.ipynb)
         - This project used Hypothesis Testing and Visualization to leverage customer's health information like smoking habits, bmi, age, and gender for checking statistical evidence to make valuable decisions of insurance business like charges for health insurance.
         
         * ***[3Ms and Distribution of BMI](https://github.com/sharmapratik88/AIML-Projects/blob/master/01_Applied%20Stats/images/bmi_distribution.png)***
         * ***[3Ms and Distribution of Charges](https://github.com/sharmapratik88/AIML-Projects/blob/master/01_Applied%20Stats/images/charges_distribution.png)***
         * ***[Distribution of Charges by # of Children](https://github.com/sharmapratik88/AIML-Projects/blob/master/01_Applied%20Stats/images/charges_%23_child_dist.png)***
         * ***[Distribution of BMI of Female with # Children](https://github.com/sharmapratik88/AIML-Projects/blob/master/01_Applied%20Stats/images/female_child_dist.png)***
    
**2. Supervised Machine Learning**
   - Covers Multiple Variable Linear regression, Logistic regression, Naive Bayes classifiers, Multiple regression, K-NN classification, Support vector machines
      - **Project link:** [Supervised Machine Learning](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/02_Supervised%20Machine%20Learning.ipynb)
        - Identified potential loan customers for Thera Bank using classification techniques. Compared models built with Logistic Regression and KNN algorithm in order to select the best performing one.
        
        * ***[Personal Loan vs Income](https://github.com/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/images/personal_loan.png)***
        * ***[Model Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/images/scores.PNG)***
        ![Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/images/scores.PNG)
        * ***[Model Scores with SMOTE](https://github.com/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/images/scores_smote.PNG)***
        ![Scores with SMOTE](https://github.com/sharmapratik88/AIML-Projects/blob/master/02_Supervised%20Machine%20Learning/images/scores_smote.PNG)

**3. Ensemble Techniques**
   - Covers Decision Trees, Bagging, Random Forests, Boosting
      - **Project link:** [Ensemble Technique](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/03_Ensemble%20Techniques/03_Ensemble%20Techniques.ipynb)
         - Leveraged customer information of bank marketing campaigns to predict whether a customer will subscribe to term deposit or not. Different classification algorithms like Decision tree, Logistic Regression were used. Ensemble techniques like Random forest were used to further improve the classification results.
        
        * ***[Decision Tree](https://github.com/sharmapratik88/AIML-Projects/blob/master/03_Ensemble%20Techniques/images/dtree.png)***
        * ***[Random Forest](https://github.com/sharmapratik88/AIML-Projects/blob/master/03_Ensemble%20Techniques/images/rforest.png)***
        * ***[Model Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/03_Ensemble%20Techniques/images/scores.PNG)***
        ![Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/03_Ensemble%20Techniques/images/scores.PNG)

**4. Unsupervised Machine Learning**
   - Covers K-means clustering, High-dimensional clustering, Hierarchical clustering, Dimension Reduction-PCA4
      - **Project link:** [Unsupervised Learning](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/04_Unsupervised%20Learning.ipynb)
         - Classified vehicles into different types based on silhouettes which may be viewed from many angles. Used PCA in order to reduce dimensionality and SVM for classification

        * ***[Columns after removing outliers](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/without_outliers.png)***
        * ***[Correlation Matrix](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/corr_matrix.png)***
        * ***[PCA Explained Variance](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/explained_var.png)***
        * ***[Dimensionality Reduction](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/dimensionality_red.png)***
        ![DR](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/dimensionality_red.png)
        * ***[Training vs Cross-Validation Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/scores.png)***
        ![scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/04_Unsupervised%20Learning/images/scores.png)

**5. Feature Engineering Techniques**
   - Covers Exploratory Data Analysis, Feature Exploration and Selection Techniques, Hyperparameter Tuning
      - **Project link:** [Feature Engineering Techniques](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/05_Feature_Engineering_Techniques.ipynb)
        - Used feature exploration and selection technique to predict the strength of high-performance concrete. Used regression models like decision tree regressors to find out the most important features and predict the strength. Cross-validation techniques and grid search were used to tune the parameters for the best model performance.

        * ***[OLS Regression Results](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/reg.PNG)***
        * ***[Leverage v.s. Studentized Residuals](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/leverage.png)***
        ![leverage](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/leverage.png)
        * ***[Pairwise Feature Importance](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/FI.png)***
        * ***[Clusters](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/clusters.png)***
        * ***[Model Scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/scores.PNG)***
        ![scores](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/scores.PNG)
        * ***[Boostrapping Confidence Level](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/bootstraping_conf.png)***
        ![confidence](https://github.com/sharmapratik88/AIML-Projects/blob/master/05_Feature%20Engineering%20Techniques/images/bootstraping_conf.png)
        
    
**6. Recommendation Systems**
   - Covers Introduction to Recommendation systems, Popularity based model, Hybrid models, Content based recommendation system, Collaborative filtering (User similarity & Item similarity)
      - **Project link:** [Recommendation Systems](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/06_Recommendation%20Systems/06_Recommendation_System.ipynb)
        - Project involved building recommendation systems for Amazon products. A popularity-based model and a collaborative filtering filtering models were used and evaluated to recommend top-10 product for a user.
        * ***[Recommendation](https://github.com/sharmapratik88/AIML-Projects/blob/master/06_Recommendation%20Systems/images/recommendation.PNG)***
        ![recommend](https://github.com/sharmapratik88/AIML-Projects/blob/master/06_Recommendation%20Systems/images/recommendation.PNG)
    
**7. Neural Networks**
   - Covers Gradient Descent, Batch Normalization, Hyper parameter tuning, Tensor Flow & Keras for Neural Networks & Deep Learning, Introduction to Perceptron & Neural Networks, Activation and Loss functions, Deep Neural Networks
      - **Project link:** [Neural Networks](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/07_Neural%20Networks/07_Neural_Network.ipynb)
        - SVHN is a real-world image dataset for developing object recognition algorithms with a requirement on data formatting but comes from a significantly harder, unsolved, real-world problem (recognizing digits and numbers in natural scene images). SVHN is obtained from house numbers in Google Street View images. The objective of the project is to learn how to implement a simple image classification pipeline based on the k-Nearest Neighbour and a deep neural network.
        * ***[Model Accuracy](https://github.com/sharmapratik88/AIML-Projects/blob/master/07_Neural%20Networks/images/model_acc.png)***
        * ***[Model Loss](https://github.com/sharmapratik88/AIML-Projects/blob/master/07_Neural%20Networks/images/model_loss.png)***

**8. Computer Vision**
   - Covers Introduction to Convolutional Neural Networks, Convolution, Pooling, Padding & its mechanisms, Transfer Learning, Forward propagation & Backpropagation for CNNs, CNN architectures like AlexNet, VGGNet, InceptionNet & ResNet
      - **Project link:** [Face Detection](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/08_Computer_Vision_Face_Detection.ipynb)
         - Recognize, identify and classify faces within images using CNN and image recognition algorithms. In this hands-on project, the goal is to build a face recognition system, which includes building a face detector to locate the position of a face in an image and a face identification model to recognize whose face it is by matching it to the existing database of faces.
         
         * ***[Image](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/orig.png)***
         
         ![image](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/orig.png)
         
         * ***[Face Detected (Mask)](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/detected.png)***
         
         ![mask](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/detected.png)
         
         * ***[Face & Mask](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/face_detected.png)***
         
         ![mask](https://github.com/sharmapratik88/AIML-Projects/blob/master/08_Computer%20Vision/images/face_detected.png)

**9. Advanced Computer Vision**
   - Covers Semantic segmentation, Siamese Networks, YOLO, Object & face recognition using techniques above
      - **Project link:** [Face Recognition](https://github.com/sharmapratik88/AIML-Projects/blob/master/09_Advanced%20Computer%20Vision/09_Computer_Vision_Face_Recognition.ipynb)
         - Face recognition deals with Computer Vision a discipline of Artificial Intelligence and uses techniques of image processing and deep learning. The objective of this project is to build a face recognition system, which includes building a face detector to locate the position of a face in an image and a face identification model to recognize whose face it is by matching it to the existing database of faces.
         
         * ***Aligned Faces Dataset from Pinterest (10k+ images of 100 celebs) - Face recognition model recognises similar faces with an accuracy of 97% and F1 score of 96%.***
         * ***[Faces Identified - Results](https://github.com/sharmapratik88/AIML-Projects/blob/master/09_Advanced%20Computer%20Vision/images/results.png)***
         ![result](https://github.com/sharmapratik88/AIML-Projects/blob/master/09_Advanced%20Computer%20Vision/images/results.png)
   
**10. Statistical NLP (Natural Language Processing)**
   - Covers Bag of Words Model, POS Tagging, Tokenization, Word Vectorizer, TF-IDF, Named Entity Recognition, Stop Words
      - **Project link:** [NLP Sentiment Analysis](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/10_NLP_Sentiment%20Analysis/10_Natural_Language_Processing_Sentiment_Analysis.ipynb)
         - The objective of this project is to build a text classification model that analyses the customer's sentiments based on their reviews in the IMDB database. The model uses a complex deep learning model to build an embedding layer followed by a classification algorithm to analyze the sentiment of the customers.
 
         * ***[Model](https://github.com/sharmapratik88/AIML-Projects/blob/master/10_NLP_Sentiment%20Analysis/images/sequential_model.JPG)***
         * ***[Results](https://github.com/sharmapratik88/AIML-Projects/blob/master/10_NLP_Sentiment%20Analysis/images/results.JPG)***
         
         ![Results](https://github.com/sharmapratik88/AIML-Projects/blob/master/10_NLP_Sentiment%20Analysis/images/results.JPG)
         
**11. Sequential NLP (Natural Language Processing)**
   - Covers Introduction to Sequential data, Vanishing & Exploding gradients in RNNs, LSTMs, GRUs (Gated recurrent unit), Case study: Sentiment analysis, RNNs and its mechanisms, Time series analysis, LSTMs with attention mechanism, Case study: Machine Translation
      - **Project link:** [NLP Sarcasm Detection](https://nbviewer.jupyter.org/github/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/11_Natural_Language_Processing_Sarcasm_Detection.ipynb)
         - The goal of this hands-on project is to analyse the headlines of the articles from news sources and detect whether they are sarcastic or not.

         * ***[WordCloud Sarcastic](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/word_cloud_sarcastic.png)***        
         * ***[WordCloud Non-Sarcasm](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/word_cloud_non_sarcastic.png)***
         * ***[Model](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/sequential_model.JPG)***
         * ***[Monitoring Performance](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/sequential_model.JPG)***
         * ***[Confusion Matrix](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/confusion_matrix.JPG)***
         
         ![Confusion Matrix](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/confusion_matrix.JPG)
         * ***[Evaluate Randomly](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/evaluate_randomly.JPG)***
         
         ![Evaluate Randomly](https://github.com/sharmapratik88/AIML-Projects/blob/master/11_NLP_Sarcasm%20Detection/images/evaluate_randomly.JPG)

## License
Released under [MIT License](https://github.com/sharmapratik88/AIML-Projects/blob/master/LICENSE)

Copyright (c) 2020 Pratik Sharma
